/*
 * RiskScape™ Copyright New Zealand Institute for Earth Science Limited
 * (Earth Sciences New Zealand) is distributed for research purposes only
 * under the terms of AGPLv3.
 *
 * RiskScape™ Copyright 2026 New Zealand Institute for Earth Science
 * Limited (Earth Sciences New Zealand). All rights reserved. Source code
 * available under the AGPLv3.
 * 
 * This program is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Affero General Public License as published by the Free
 *  Software Foundation, either version 3 of the License, or (at your option) any
 *  later version.
 * 
 * This program is distributed for RESEARCH PURPOSES ONLY, in the hope that it will
 * be useful for research and education initiatives.
 * 
 * If you are not a researcher, or you are a researcher who wishes to use this
 * program on terms other than AGPLv3 (including those who wish to restrict the
 * distribution of any source code created using this program), please contact:
 * https://riskscape.org.nz
 * 
 * This program is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Affero General Public License for more details.  You should have received a copy
 * of the GNU Affero General Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * By way of summary only, under the AGPLv3:
 *     • Permissions of this strongest copyleft license are conditioned
 *       on making available complete source code of licensed works and
 *       modifications, which include larger works using a licensed work,
 *       under the same license.
 *     • Copyright and license notices must be preserved.
 *     • Contributors provide an express grant of patent rights.
 *     • When a modified version is used to provide a service over a
 *       network, the complete source code of the modified version must be made
 *       available.
 */
package nz.org.riskscape.engine.bind.impl;

import nz.org.riskscape.engine.FailedObjectException;
import nz.org.riskscape.engine.NoSuchObjectException;
import nz.org.riskscape.engine.bind.BaseBinder;
import nz.org.riskscape.engine.bind.BindingContext;
import nz.org.riskscape.engine.types.Type;
import nz.org.riskscape.engine.types.TypeProblems;
import nz.org.riskscape.engine.typeset.IdentifiedType;
import nz.org.riskscape.engine.typeset.MissingTypeException;
import nz.org.riskscape.engine.typexp.TypeBuildingException;
import nz.org.riskscape.problem.Problems;
import nz.org.riskscape.problem.ResultOrProblems;
import nz.org.riskscape.rl.TokenTypes;
import nz.org.riskscape.rl.ast.ExpressionProblems;

public class TypeBinder extends BaseBinder {

  @Override
  public <T> ResultOrProblems<T> bindValue(BindingContext context, Object value, Class<T> destinationType) {

    Type foundType;
    try {
      // lookup the user-defined type by name
      foundType = context.getProject().getTypeSet()
              .get(TokenTypes.stripQuotes(value.toString()), context.getProblemSink());
    } catch (FailedObjectException ex) {
      // we successfully found the user-defined type...but it had problems
      return ResultOrProblems.failed(ex.getProblem());
    } catch (NoSuchObjectException noSuchEx) {
      // no user-defined type found, see if it's a type expression, e.g. 'floating'
      try {
        foundType = context.getProject().getTypeBuilder().build(value.toString());
      } catch (TypeBuildingException typeEx) {
        return ResultOrProblems.failed(
            Problems.caught(noSuchEx).withChildren(
              ExpressionProblems.get().notAValid(Type.class, value.toString()).withChildren(
                  Problems.caught(typeEx)
            )));
      }
    }
    try {
      if (foundType instanceof IdentifiedType it) {
        // check to make sure there is actually something backing the identified type because
        // user defined types can fail to build in which case the missing type exception will be thrown
        it.getUnderlyingType();
      }
      @SuppressWarnings("unchecked")
      T requiredType = (T)foundType
          .find((Class<Type>)destinationType)
          .orElse(null);

      if (requiredType == null) {
        if (foundType instanceof IdentifiedType it) {
          // if the found type is identified we report the mismatch against the underlying type because this
          // should be more useful to the the user (e.g float is not a struct)
          return ResultOrProblems.failed(
              TypeProblems.get().mismatch(value, destinationType, it.getUnderlyingType().getClass())
          );
        }
        return ResultOrProblems.failed(TypeProblems.get().mismatch(value, destinationType, foundType.getClass()));
      }

      return ResultOrProblems.of(requiredType);
    } catch (MissingTypeException typeEx) {
      return ResultOrProblems.failed(
          Problems.caught(typeEx).withChildren(
              ExpressionProblems.get().notAValid(Type.class, value.toString()).withChildren(
                  Problems.caught(typeEx)
              )));
    }
  }

  @Override
  public boolean canBind(Class<?> sourceType, Class<?> destinationType) {
    return Type.class.isAssignableFrom(destinationType);
  }

}
